ENTRY(_rollout)

/* MEMORY unused, direct addresses specified later */
MEMORY {
  FastRAM : ORIGIN = 0x000000, LENGTH = 256K
  BackRAM : ORIGIN = 0x100000, LENGTH = 1M
   LowROM : ORIGIN = 0x200000, LENGTH = 512K
  HighROM : ORIGIN = 0x280000, LENGTH = 512K
  }

SECTIONS {
	ClearVec 0 : {
		LONG(0); LONG(0);
		}
  . = 0x200000;
  _lowrom_begin = .;

	_lowrom_placement = DEFINED(_lowrom_placement) ? _lowrom_placement : _lowrom_begin;

#define PREV(name,prev) \
  _##name##_placement = _##prev##_placement + _##prev##_sizeof

#define GENSECT(name,section,insert) \
  _##name##_begin = .; \
  section _##name##_placement : AT(_##name##_begin) { \
    insert \
		. = ALIGN(4); \
    } \
  _##name##_placement_end = .; \
  _##name##_sizeof = _##name##_placement_end - _##name##_placement; \
	_##name##_end = _##name##_begin + _##name##_sizeof; \
	. = _##name##_end

_romcode_placement = _lowrom_placement;
                         GENSECT(romcode ,ROMCode ,*(.text)         );
_romdata_placement = _romcode_end;
                         GENSECT(romdata ,ROMData ,*(.rodata)       );
PREV(kicktags,romdata ); GENSECT(kicktags,KickTags,*(KickTags)      );
                         GENSECT(data    ,DataZone,*(.data)         );
PREV(bss     ,data    ); GENSECT(bss     , BSSZone,*(.bss) *(COMMON));

  _databss_sizeof = _data_sizeof + _bss_sizeof;
	_romcodedata_sizeofd4m1 = ( _romcode_sizeof + _romdata_sizeof + 3 ) / 4 - 1;

  _lowrom_end = .;

  Kickety : {
    _rollout = . + 8;
    *(Kickety)
    } >HighROM

	HighROMData : {
		*(HighROMData)
		} >HighROM

	XSum 0x2FFFF8 : {
		LONG( 0x5853554D /* 'XSUM' */ ); LONG( _xsumvalue );
		_highrom_end = .;
		}
	_lowhighrom_sizeof = _highrom_end - _lowrom_begin;
	_lowhighrom_sizeofs18m1 = (_lowhighrom_sizeof >> 18 ) - 1;

  /DISCARD/ : { *(.note) *(.comment) *(.stab) *(.stabstr) }
  /DISCARD/ : { *(.eh_frame) } /* FIXME: Aren't we fucking it up? */

  }
